<template>
  <PageContainer title="MY MODEL PHOTOS">

    <StackLayout width="100%" padding="0,10">

      <FlexboxLayout marginBottom="20" :height="isNoItems ? 'auto' : 0" width="100%" flexDirection="column" alignItems="center">
        <Label fontSize="12" color="black" text="No model photos yet." />
      </FlexboxLayout>

      <FlexboxLayout marginBottom="20" height="auto" width="100%" flexDirection="column" alignItems="center">
        <StackLayout height="auto" width="auto" horizontalAlignment="center">
          <RoundButton :width="150" :pink="true" text="MODEL UP!" @onTap="$goToScreen('member-model-up')" />
        </StackLayout>
      </FlexboxLayout>

      <FlexboxLayout marginBottom="20" :height="haveItems ? 'auto' : 0" flexDirection="column">
        <StackLayout width="100%" v-for="(modelPhoto, index) in modelPhotoList" :key="index" marginBottom="15">
          <ModelPhotoCard :modelPhoto="modelPhoto"
            @onTap="$goToScreen('member-model-photo-detail', { modelPhotoId: modelPhoto.ID })"
            @onLongPress="confirmDelete(modelPhoto.ID)" />
        </StackLayout>
      </FlexboxLayout>

    </StackLayout>
  </PageContainer>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import { GETTERS as APP_GETTERS } from '~/store';
import { ACTIONS, GETTERS } from '~/store/member';
import { GETTERS as MENU_GETTERS } from '~/store/menu';
import { getMemberModelPhotoList, deleteMemberModelPhoto } from '~/services/member';
import RoundButton from '~/components/Button/RoundButton';
import PageContainer from '../PageContainer';
import ModelPhotoCard from './ModelPhotoCard';
export default {
  props: {
  },
  components: {
    PageContainer,
    RoundButton,
    ModelPhotoCard,
  },
  watch: {
  },
  computed: {
    ...mapGetters({
      loading: APP_GETTERS.PROCESSING,
      memberId: GETTERS.MEMBER_ID,
      modelPhotoList: GETTERS.MODELPHOTOS,
    }),
    isNoItems() {
      return !this.loading && !this.modelPhotoList.length;
    },
    haveItems() {
      return !this.loading && !!this.modelPhotoList.length;
    },
  },
  methods: {
    ...mapActions({
      loadModelPhotoList: ACTIONS.LOAD_MODELPHOTOS,
    }),
    confirmDelete(modelPhotoId) {
      this.$showYesNoModal({
          message: 'Are you sure you want to delete this model photo?',
        }).then(result => {
          console.log('response to confirm: ', result);
          if (result === 'YES') {
            this.deleteModelPhoto(modelPhotoId);
          }
        });
    },
    async deleteModelPhoto(modelPhotoId) {
      try {
        const response = await deleteMemberModelPhoto(this.memberId, modelPhotoId);
        if (response && response.Status) {
          this.$showAlert(response.Status).then(() => {
            this.loadModelPhotoList(this.memberId);
          });
        } else {
          this.$showConfirm({
            message: 'Something went wrong, please try again later!',
          });
        }
      } catch (error) {
        this.$showConfirm({
          message: 'Something went wrong, please try again later!',
        });
      }
    },
  },
  mounted() {
    this.loadModelPhotoList(this.memberId);
  },
};
</script>

<style scoped>
</style>
